#%define BuildRoot /tmp/%{name}-%{version}
%define __spec_install_post %{nil}

Summary: A web-based administration interface for Unix systems.
Name: webmin
Version: 1.220
Release: 3AX
Provides: %{name}-%{version}
PreReq: /bin/sh /usr/bin/perl sh-utils perl-Net-SSLeay
Requires: /bin/sh /usr/bin/perl
AutoReq: 0
Copyright: Freeware
Group: System/Tools
Source: http://www.webmin.com/download/%{name}-%{version}.tar.gz

Source100: webmin-miracle-theme.wbt
Source101: webmin-gnome-menu-netscape
Source102: webmin-gnome-menu-mozilla
Source103: webmin_icon.png
Source104: webmin-desktop-link
Source105: webmin-scramble.pl

Patch100: webmin-1.220-swat.cgi-miracle.patch
Patch101: webmin-swat_save.cgi-miracle.patch
Patch102: webmin-servers-lib.pl-miracle.patch
#Patch103: webmin-majordomo-config-miracle.patch
Patch104: webmin-pam-miracle.patch
Patch105: webmin-setup.sh-miracle.patch
#Patch106: webmin-1.150-os_list.txt-miracle.patch
Patch107: webmin-defaulttheme.patch
Patch108: webmin-1.220-delete_modules.patch

BuildRoot: /tmp/%{name}-%{version}
BuildArchitectures: noarch
%description
A web-based administration interface for Unix systems. Using Webmin you can
configure DNS, Samba, NFS, local/remote filesystems and more using your
web browser.

After installation, enter the URL https://localhost:10000/ into your
browser and login as root with your root password.

%prep
%setup -q -a 100

#%patch100 -p1
#%patch101 -p1
%patch102 -p1
#%patch103 -p1
%patch104 -p1
%patch105 -p1
#%patch106 -p1
%patch107 -p1
%patch108 -p1

%build
(find . -name '*.cgi' ; find . -name '*.pl') | perl perlpath.pl /usr/bin/perl -
rm -f mount/freebsd-mounts*
rm -f mount/openbsd-mounts*
rm -f mount/macos-mounts*
rm -f webmin-gentoo-init
chmod -R og-w .

%install
mkdir -p %{buildroot}/usr/libexec/webmin
mkdir -p %{buildroot}/etc/sysconfig/daemons
mkdir -p %{buildroot}/etc/rc.d/{rc0.d,rc1.d,rc2.d,rc3.d,rc5.d,rc6.d}
mkdir -p %{buildroot}/etc/init.d
mkdir -p %{buildroot}/etc/pam.d
cp -rp * %{buildroot}/usr/libexec/webmin
cp webmin-daemon %{buildroot}/etc/sysconfig/daemons/webmin
cp webmin-init %{buildroot}/etc/init.d/webmin
cp webmin-pam %{buildroot}/etc/pam.d/webmin
echo rpm >%{buildroot}/usr/libexec/webmin/install-type

# Add Gnome menu
install -m 755 -d %{buildroot}/etc/X11/applnk/System
install -m 755 -d %{buildroot}/etc/X11/starthere
install -m 644 %{SOURCE102} %{buildroot}/etc/X11/applnk/System/webmin.desktop
install -m 644 %{SOURCE102} %{buildroot}/etc/X11/starthere/webmin.desktop
# Add Desktop Icon
install -m 755 -d %{buildroot}/usr/share/pixmaps
install -m 644 %{SOURCE103} %{buildroot}/usr/share/pixmaps/webmin_icon.png
install -m 755 -d %{buildroot}/usr/lib/desktop-links/
install -m 644 %{SOURCE104} %{buildroot}/usr/lib/desktop-links/webmin.links
# Install scramble.pl
install -m 744 %{SOURCE105} %{buildroot}/usr/libexec/webmin/samba/scramble.pl

# remove Japanese message file for file manager
# since java applet can't display japanese correctly.
#if [ -e %{buildroot}/usr/libexec/webmin/file/lang/ja_JP.euc ]; then
#        rm -f %{buildroot}/usr/libexec/webmin/file/lang/ja_JP.euc
#fi

%clean
#%{rmDESTDIR}
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
/usr/libexec/webmin
/etc/sysconfig/daemons/webmin
/etc/init.d/webmin
%config /etc/pam.d/webmin
/etc/X11/applnk/System/webmin.desktop
/etc/X11/starthere/webmin.desktop
/usr/share/pixmaps/webmin_icon.png
/usr/lib/desktop-links/webmin.links

%pre
perl <<EOD;
# maketemp.pl
# Create the /tmp/.webmin directory if needed

\$tmp_dir = \$ENV{'tempdir'} || "/tmp/.webmin";

while(\$tries++ < 10) {
	local @st = lstat(\$tmp_dir);
	exit(0) if (\$st[4] == \$< && (-d _) && (\$st[2] & 0777) == 0755);
	if (@st) {
		unlink(\$tmp_dir) || rmdir(\$tmp_dir) ||
			system("/bin/rm -rf ".quotemeta(\$tmp_dir));
		}
	mkdir(\$tmp_dir, 0755) || next;
	chown(\$<, \$(, \$tmp_dir);
	chmod(0755, \$tmp_dir);
	}
exit(1);


EOD
if [ "$?" != "0" ]; then
	echo "Failed to create or check temp files directory /tmp/.webmin"
	exit 1
fi
perl >/tmp/.webmin/$$.check <<EOD;
if (\`cat /etc/miraclelinux-release 2>/dev/null\` =~ /MIRACLE\\s+LINUX\\s+V4\\.0\\s+(\\S+)/i) {
	print "oscheck='MIRACLE LINUX 4.0'\\n";
	}

EOD
. /tmp/.webmin/$$.check
rm -f /tmp/.webmin/$$.check
if [ ! -r /etc/webmin/config ]; then
	if [ "$oscheck" = "" ]; then
		echo Unable to identify operating system
		exit 2
	fi
	echo Operating system is $oscheck
	if [ "$WEBMIN_PORT" != "" ]; then
                port=$WEBMIN_PORT
        else
                port=10000
        fi
fi

%post
inetd=`grep "^inetd=" /etc/webmin/miniserv.conf 2>/dev/null | sed -e 's/inetd=//g'`
if [ -f "/var/webmin/miniserv.pid" ]; then
	pid=`cat /var/webmin/miniserv.pid`
	kill -0 $pid >/dev/null 2>&1
	if [ "$?" = "0" ]; then
		active=1
	else
		active=0
	fi
else
	active=0
fi
if [ "$1" != 1 ]; then
	# Upgrading the RPM, so stop the old webmin properly
	if [ "$inetd" = 0 ]; then
		/sbin/service webmin stop >/dev/null 2>&1
	fi
else
	/sbin/chkconfig --add webmin
	/sbin/chkconfig webmin off
fi

cd /usr/libexec/webmin
config_dir=/etc/webmin
var_dir=/var/webmin
perl=/usr/bin/perl
autoos=3
if [ "$WEBMIN_PORT" != "" ]; then
	port=$WEBMIN_PORT
else
	port=10000
fi
login=root
crypt=x
host=`hostname`
ssl=1
atboot=1
nochown=1
autothird=1
noperlpath=1
nouninstall=1
nostart=1
allow=localhost
export config_dir var_dir perl autoos port login crypt ssl nochown autothird noperlpath nouninstall nostart allow host
./setup.sh >/tmp/webmin-setup.out 2>&1
if [ "" != "1" -a "$active" = "1" ]; then
	/etc/init.d/webmin start >/dev/null 2>&1 </dev/null
fi
cat >/etc/webmin/uninstall.sh <<EOFF
#!/bin/sh
printf "Are you sure you want to uninstall Webmin? (y/n) : "
read answer
printf "\n"
if [ "\$answer" = "y" ]; then
	echo "Removing webmin RPM .."
	rpm -e --nodeps webmin
	echo "Done!"
fi
EOFF
chmod +x /etc/webmin/uninstall.sh
echo "Webmin install complete. You can login to https://localhost:$port/"
echo "as any user on your system after starting webmin service."

%preun
if [ "$1" = 0 ]; then
	grep root=/usr/libexec/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
	if [ "$?" = 0 ]; then
		# RPM is being removed, and no new version of webmin
		# has taken it's place. Run uninstalls and stop the server
		echo "Running uninstall scripts .."
		(cd /usr/libexec/webmin ; WEBMIN_CONFIG=/etc/webmin WEBMIN_VAR=/var/webmin LANG= /usr/libexec/webmin/run-uninstalls.pl)
		/etc/init.d/webmin stop >/dev/null 2>&1
		/sbin/chkconfig --del webmin
		/bin/true
	fi
fi

%postun
if [ "$1" = 0 ]; then
	grep root=/usr/libexec/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
	if [ "$?" = 0 ]; then
		# RPM is being removed, and no new version of webmin
		# has taken it's place. Delete the config files
		rm -rf /etc/webmin /var/webmin
	fi
fi

%changelog
* Tue Sep 13 2005 Shiro Yamada <shiro@miraclelinux.com> 1.220-3AX
- delete unnecessary modules
- disable swat patch

* Wed Sep  7 2005 Shiro Yamada <shiro@miraclelinux.com> 1.220-2AX
- update swat patch to use Jcode instead of jcode.pl

* Fri Dec 24 2004 Shiro Yamada <shiro@miraclelinux.com> 1.170-2AX
- let root user to login instead of admin

* Tue Dec 21 2004 Shiro Yamada <shiro@miraclelinux.com> 1.170-1AX
- upgraded to 1.170

* Tue Jun 15 2004 Shiro Yamada <shiro@miraclelinux.com> 1.150-1AX
- upgraded to 1.150

* Tue May 18 2004 Shiro Yamada <shiro@miraclelinux.com> 1.140-2AX
- cleaning up post section
- only start webmin service when it was previously running

* Mon Apr  5 2004 Shiro Yamada <shiro@miraclelinux.com> 1.140-1AX
- Rebuild for Asianux 1.0

* Wed May 28 2003 Yuji Oishi <yoishi@miraclelinux.com>
- delete Vendor tag.
- add RHASML flag setting
- add webmin-gnome-menu-netscape and webmin-gnome-menu-mozilla.
- add webmin_icon.png.
- add webmin-desktop-link.
- add scramble.pl.
- add patch webmin-swat.cgi-miracle.patch.
- add patch webmin-swat_save.cgi-miracle.patch.
- add patch webmin-servers-lib.pl-miracle.patch.
- add patch webmin-majordomo-config-miracle.patch.
- add patch webmin-pam-miracle.patch.
- add "allow=localhost" to forbid remote access in spec file.
- add "export crypt(=x)" in spec file.
- change the description such as "http://localhost:10000" to "https://...." in
  spec file.
- add "sh-utils perl-Net-SSLeay" on PreReq, "jcode.pl" on Requires.
- save config files(config, miniserv.conf) as *.wm_rpmsave when updating
  in spec file
- remove file/lang/ja_JP.euc since java applet can't show Japanese.
- add miraclelinux-release checking line in spec file.
- delete making link in /etc/rc.d/rc*.d, execute chkconfig instead.
- add patch webmin-setup.sh-miracle.patch
- add patch os_list.txt-miracle.patch.
- add patch apache-config-redhat-linux-7.1.patch.
- delete modules which don't work on Miracle Linux
- create root.acl file to fix security problem
